diff --git a/cli/src/cli-rpc-ops.c b/cli/src/cli-rpc-ops.c
index a4b0d2e2809..da0e3b6db41 100644
--- a/cli/src/cli-rpc-ops.c
+++ b/cli/src/cli-rpc-ops.c
@@ -320,7 +320,7 @@ static int
 gf_cli_output_peer_status(dict_t *dict, int count)
 {
     int ret = -1;
-    char *uuid_buf = NULL;
+    uuid_t uuid;
     char *hostname_buf = NULL;
     int32_t i = 1;
     char key[256] = {
@@ -335,8 +335,8 @@ gf_cli_output_peer_status(dict_t *dict, int count)
     cli_out("Number of Peers: %d", count);
     i = 1;
     while (i <= count) {
-        keylen = snprintf(key, sizeof(key), "friend%d.uuid", i);
-        ret = dict_get_strn(dict, key, keylen, &uuid_buf);
+        keylen = snprintf(key, sizeof(key), GF_FRIEND_UUID_KEY, i);
+        ret = dict_get_gfuuid(dict, key, &uuid);
         if (ret)
             goto out;
 
@@ -360,7 +360,7 @@ gf_cli_output_peer_status(dict_t *dict, int count)
             goto out;
 
         cli_out("\nHostname: %s\nUuid: %s\nState: %s (%s)", hostname_buf,
-                uuid_buf, state, connected_str);
+                uuid_utoa(uuid), state, connected_str);
 
         keylen = snprintf(key, sizeof(key), "friend%d.hostname_count", i);
         ret = dict_get_int32n(dict, key, keylen, &hostname_count);
@@ -387,7 +387,9 @@ static int
 gf_cli_output_pool_list(dict_t *dict, int count)
 {
     int ret = -1;
-    char *uuid_buf = NULL;
+    uuid_t uuid = {
+        0,
+    };
     char *hostname_buf = NULL;
     int32_t hostname_len = 8; /*min len 8 chars*/
     int32_t i = 1;
@@ -418,8 +420,8 @@ gf_cli_output_pool_list(dict_t *dict, int count)
 
     i = 1;
     while (i <= count) {
-        keylen = snprintf(key, sizeof(key), "friend%d.uuid", i);
-        ret = dict_get_strn(dict, key, keylen, &uuid_buf);
+        keylen = snprintf(key, sizeof(key), GF_FRIEND_UUID_KEY, i);
+        ret = dict_get_gfuuid(dict, key, &uuid);
         if (ret)
             goto out;
 
@@ -437,7 +439,7 @@ gf_cli_output_pool_list(dict_t *dict, int count)
         else
             connected_str = "Disconnected";
 
-        cli_out("%s\t%-*s\t%s ", uuid_buf, hostname_len, hostname_buf,
+        cli_out("%s\t%-*s\t%s ", uuid_utoa(uuid), hostname_len, hostname_buf,
                 connected_str);
         i++;
     }
@@ -9210,6 +9212,9 @@ cli_get_single_snap_status(dict_t *dict, char *keyprefix)
     char key[64] = ""; /* keyprefix is ""status.snap0" */
     int i = 0;
     int volcount = 0;
+    uuid_t uuid = {
+        0,
+    };
     char *get_buffer = NULL;
 
     GF_ASSERT(dict);
@@ -9227,17 +9232,17 @@ cli_get_single_snap_status(dict_t *dict, char *keyprefix)
     }
     cli_out("\nSnap Name : %s", get_buffer);
 
-    ret = snprintf(key, sizeof(key), "%s.uuid", keyprefix);
+    ret = snprintf(key, sizeof(key), GF_UUID_KEY, keyprefix);
     if (ret < 0) {
         goto out;
     }
 
-    ret = dict_get_str(dict, key, &get_buffer);
+    ret = dict_get_gfuuid(dict, key, &uuid);
     if (ret) {
         gf_log("cli", GF_LOG_ERROR, "Unable to get snap UUID");
         goto out;
     }
-    cli_out("Snap UUID : %s", get_buffer);
+    cli_out("Snap UUID : %s", uuid_utoa(uuid));
 
     ret = snprintf(key, sizeof(key), "%s.volcount", keyprefix);
     if (ret < 0) {
diff --git a/cli/src/cli-xml-output.c b/cli/src/cli-xml-output.c
index 4c3c7ab55d1..cf44810acfa 100644
--- a/cli/src/cli-xml-output.c
+++ b/cli/src/cli-xml-output.c
@@ -2424,7 +2424,9 @@ cli_xml_output_vol_info(cli_local_t *local, dict_t *dict)
     int count = 0;
     char *volname = NULL;
     char *volume_id = NULL;
-    char *uuid = NULL;
+    uuid_t uuid = {
+        0,
+    };
     int type = 0;
     int status = 0;
     int brick_count = 0;
@@ -2576,12 +2578,12 @@ cli_xml_output_vol_info(cli_local_t *local, dict_t *dict)
             ret = xmlTextWriterStartElement(local->writer, (xmlChar *)"brick");
             XML_RET_CHECK_AND_GOTO(ret, out);
 
-            snprintf(key, sizeof(key), "volume%d.brick%d.uuid", i, j);
-            ret = dict_get_str(dict, key, &uuid);
+            snprintf(key, sizeof(key), GF_VOLUME_BRICK_UUID_KEY, i, j);
+            ret = dict_get_gfuuid(dict, key, &uuid);
             if (ret)
                 goto out;
             ret = xmlTextWriterWriteFormatAttribute(
-                local->writer, (xmlChar *)"uuid", "%s", uuid);
+                local->writer, (xmlChar *)"uuid", "%s", uuid_utoa(uuid));
             XML_RET_CHECK_AND_GOTO(ret, out);
 
             snprintf(key, sizeof(key), "volume%d.brick%d", i, j);
@@ -2798,7 +2800,9 @@ cli_xml_output_peer_status(dict_t *dict, int op_ret, int op_errno,
     xmlTextWriterPtr writer = NULL;
     xmlDocPtr doc = NULL;
     int count = 0;
-    char *uuid = NULL;
+    uuid_t uuid = {
+        0,
+    };
     char *hostname = NULL;
     int connected = 0;
     int state_id = 0;
@@ -2833,13 +2837,13 @@ cli_xml_output_peer_status(dict_t *dict, int op_ret, int op_errno,
         ret = xmlTextWriterStartElement(writer, (xmlChar *)"peer");
         XML_RET_CHECK_AND_GOTO(ret, out);
 
-        snprintf(key, sizeof(key), "friend%d.uuid", i);
-        ret = dict_get_str(dict, key, &uuid);
+        snprintf(key, sizeof(key), GF_FRIEND_UUID_KEY, i);
+        ret = dict_get_gfuuid(dict, key, &uuid);
         if (ret)
             goto out;
 
         ret = xmlTextWriterWriteFormatElement(writer, (xmlChar *)"uuid", "%s",
-                                              uuid);
+                                              uuid_utoa(uuid));
         XML_RET_CHECK_AND_GOTO(ret, out);
 
         snprintf(key, sizeof(key), "friend%d.hostname", i);
@@ -2920,7 +2924,9 @@ cli_xml_output_vol_rebalance_status(xmlTextWriterPtr writer, dict_t *dict,
     int ret = -1;
     int count = 0;
     char *node_name = NULL;
-    char *node_uuid = NULL;
+    uuid_t uuid = {
+        0,
+    };
     uint64_t files = 0;
     uint64_t size = 0;
     uint64_t lookups = 0;
@@ -2979,12 +2985,12 @@ cli_xml_output_vol_rebalance_status(xmlTextWriterPtr writer, dict_t *dict,
                                               "%s", node_name);
         XML_RET_CHECK_AND_GOTO(ret, out);
 
-        snprintf(key, sizeof(key), "node-uuid-%d", i);
-        ret = dict_get_str(dict, key, &node_uuid);
+        snprintf(key, sizeof(key), GF_NODE_UUID_KEY, i);
+        ret = dict_get_gfuuid(dict, key, &uuid);
         if (ret)
             goto out;
         ret = xmlTextWriterWriteFormatElement(writer, (xmlChar *)"id", "%s",
-                                              node_uuid);
+                                              uuid_utoa(uuid));
         XML_RET_CHECK_AND_GOTO(ret, out);
 
         snprintf(key, sizeof(key), "files-%d", i);
@@ -4624,6 +4630,9 @@ cli_xml_snapshot_status_per_snap(xmlTextWriterPtr writer, xmlDocPtr doc,
     int volcount = 0;
     int i = 0;
     char *buffer = NULL;
+    uuid_t uuid = {
+        0,
+    };
     char key[PATH_MAX] = "";
 
     GF_ASSERT(writer);
@@ -4646,16 +4655,16 @@ cli_xml_snapshot_status_per_snap(xmlTextWriterPtr writer, xmlDocPtr doc,
                                           buffer);
     XML_RET_CHECK_AND_GOTO(ret, out);
 
-    snprintf(key, sizeof(key), "%s.uuid", keyprefix);
+    snprintf(key, sizeof(key), GF_UUID_KEY, keyprefix);
 
-    ret = dict_get_str(dict, key, &buffer);
+    ret = dict_get_gfuuid(dict, key, &uuid);
     if (ret) {
         gf_log("cli", GF_LOG_ERROR, "Unable to get snap UUID");
         goto out;
     }
 
     ret = xmlTextWriterWriteFormatElement(writer, (xmlChar *)"uuid", "%s",
-                                          buffer);
+                                          uuid_utoa(uuid));
     XML_RET_CHECK_AND_GOTO(ret, out);
 
     snprintf(key, sizeof(key), "%s.volcount", keyprefix);
diff --git a/libglusterfs/src/glusterfs/glusterfs.h b/libglusterfs/src/glusterfs/glusterfs.h
index 5ec7e62f3bd..4ed992f36c6 100644
--- a/libglusterfs/src/glusterfs/glusterfs.h
+++ b/libglusterfs/src/glusterfs/glusterfs.h
@@ -63,7 +63,6 @@
 #define O_PATH 010000000 /* from asm-generic/fcntl.h */
 #endif
 
-
 #ifndef EBADFD
 /* Mac OS X does not have EBADFD */
 #define EBADFD EBADF
@@ -456,6 +455,12 @@ fop_enum_to_pri_string(glusterfs_fop_t fop);
 /* key value which quick read uses to get small files in lookup cbk */
 #define GF_CONTENT_KEY "glusterfs.content"
 
+/* Used both in glusterd and cli. */
+#define GF_VOLUME_BRICK_UUID_KEY "volume%d.brick%d.uuid"
+#define GF_FRIEND_UUID_KEY "friend%d.uuid"
+#define GF_NODE_UUID_KEY "node%d.uuid"
+#define GF_UUID_KEY "%s.uuid"
+
 struct _xlator_cmdline_option {
     struct list_head cmd_args;
     char *volume;
diff --git a/xlators/mgmt/glusterd/src/glusterd-handler.c b/xlators/mgmt/glusterd/src/glusterd-handler.c
index 8134a8b35a8..96b931ddd4d 100644
--- a/xlators/mgmt/glusterd/src/glusterd-handler.c
+++ b/xlators/mgmt/glusterd/src/glusterd-handler.c
@@ -537,9 +537,6 @@ glusterd_add_volume_detail_to_dict(glusterd_volinfo_t *volinfo, dict_t *volumes,
         char brick[1024] = {
             0,
         };
-        char brick_uuid[64] = {
-            0,
-        };
         len = snprintf(brick, sizeof(brick), "%s:%s", brickinfo->hostname,
                        brickinfo->path);
         if ((len < 0) || (len >= sizeof(brick))) {
@@ -555,16 +552,8 @@ glusterd_add_volume_detail_to_dict(glusterd_volinfo_t *volinfo, dict_t *volumes,
                     "Key=%s", key, NULL);
             goto out;
         }
-        keylen = snprintf(key, sizeof(key), "volume%d.brick%d.uuid", count, i);
-        snprintf(brick_uuid, sizeof(brick_uuid), "%s",
-                 uuid_utoa(brickinfo->uuid));
-        buf = gf_strdup(brick_uuid);
-        if (!buf) {
-            gf_smsg(this->name, GF_LOG_ERROR, errno, GD_MSG_STRDUP_FAILED,
-                    "brick_uuid=%s", brick_uuid, NULL);
-            goto out;
-        }
-        ret = dict_set_dynstrn(volumes, key, keylen, buf);
+        snprintf(key, sizeof(key), GF_VOLUME_BRICK_UUID_KEY, count, i);
+        ret = dict_set_gfuuid(volumes, key, brickinfo->uuid, true);
         if (ret) {
             gf_smsg(this->name, GF_LOG_ERROR, -ret, GD_MSG_DICT_SET_FAILED,
                     "Key=%s", key, NULL);
@@ -2855,8 +2844,6 @@ __glusterd_handle_friend_update(rpcsvc_request_t *req)
     char key[32] = {
         0,
     };
-    int keylen;
-    char *uuid_buf = NULL;
     int i = 1;
     int count = 0;
     uuid_t uuid = {
@@ -2933,11 +2920,10 @@ __glusterd_handle_friend_update(rpcsvc_request_t *req)
 
     args.mode = GD_MODE_ON;
     while (i <= count) {
-        keylen = snprintf(key, sizeof(key), "friend%d.uuid", i);
-        ret = dict_get_strn(dict, key, keylen, &uuid_buf);
+        snprintf(key, sizeof(key), GF_FRIEND_UUID_KEY, i);
+        ret = dict_get_gfuuid(dict, key, &uuid);
         if (ret)
             goto out;
-        gf_uuid_parse(uuid_buf, uuid);
 
         if (!gf_uuid_compare(uuid, MY_UUID)) {
             gf_msg(this->name, GF_LOG_INFO, 0, GD_MSG_UUID_RECEIVED,
@@ -4274,9 +4260,6 @@ glusterd_list_friends(rpcsvc_request_t *req, dict_t *dict, int32_t flags)
     gf1_cli_peer_list_rsp rsp = {
         0,
     };
-    char my_uuid_str[64] = {
-        0,
-    };
     char key[64] = {
         0,
     };
@@ -4312,9 +4295,8 @@ glusterd_list_friends(rpcsvc_request_t *req, dict_t *dict, int32_t flags)
 
     if (flags == GF_CLI_LIST_POOL_NODES) {
         count++;
-        keylen = snprintf(key, sizeof(key), "friend%d.uuid", count);
-        uuid_utoa_r(MY_UUID, my_uuid_str);
-        ret = dict_set_strn(friends, key, keylen, my_uuid_str);
+        snprintf(key, sizeof(key), GF_FRIEND_UUID_KEY, count);
+        ret = dict_set_gfuuid(friends, key, MY_UUID, true);
         if (ret) {
             gf_smsg(this->name, GF_LOG_ERROR, -ret, GD_MSG_DICT_SET_FAILED,
                     "Key=%s", key, NULL);
@@ -5948,7 +5930,7 @@ glusterd_get_state(rpcsvc_request_t *req, dict_t *dict)
     {
         fprintf(fp, "Peer%d.primary_hostname: %s\n", ++count,
                 peerinfo->hostname);
-        fprintf(fp, "Peer%d.uuid: %s\n", count, gd_peer_uuid_str(peerinfo));
+        fprintf(fp, "Peer%d.uuid: %s\n", count, uuid_utoa(peerinfo->uuid));
         fprintf(fp, "Peer%d.state: %s\n", count,
                 glusterd_friend_sm_state_name_get(peerinfo->state));
         fprintf(fp, "Peer%d.connected: %s\n", count,
diff --git a/xlators/mgmt/glusterd/src/glusterd-op-sm.c b/xlators/mgmt/glusterd/src/glusterd-op-sm.c
index 0fef6038d49..78f8e7512e3 100644
--- a/xlators/mgmt/glusterd/src/glusterd-op-sm.c
+++ b/xlators/mgmt/glusterd/src/glusterd-op-sm.c
@@ -4882,7 +4882,6 @@ glusterd_op_volume_dict_uuid_to_hostname(dict_t *dict, const char *key_fmt,
     int i = 0;
     char key[128];
     int keylen;
-    char *uuid_str = NULL;
     uuid_t uuid = {
         0,
     };
@@ -4894,26 +4893,17 @@ glusterd_op_volume_dict_uuid_to_hostname(dict_t *dict, const char *key_fmt,
 
     for (i = idx_min; i < idx_max; i++) {
         keylen = snprintf(key, sizeof(key), key_fmt, i);
-        ret = dict_get_strn(dict, key, keylen, &uuid_str);
+        ret = dict_get_gfuuid(dict, key, &uuid);
         if (ret) {
             ret = 0;
             continue;
         }
 
-        gf_msg_debug(this->name, 0, "Got uuid %s", uuid_str);
-
-        ret = gf_uuid_parse(uuid_str, uuid);
-        /* if parsing fails don't error out
-         * let the original value be retained
-         */
-        if (ret) {
-            ret = 0;
-            continue;
-        }
+        gf_msg_debug(this->name, 0, "Got uuid %s", uuid_utoa(uuid));
 
         hostname = glusterd_uuid_to_hostname(uuid);
         if (hostname) {
-            gf_msg_debug(this->name, 0, "%s -> %s", uuid_str, hostname);
+            gf_msg_debug(this->name, 0, "%s -> %s", uuid_utoa(uuid), hostname);
             ret = dict_set_dynstrn(dict, key, keylen, hostname);
             if (ret) {
                 gf_msg(this->name, GF_LOG_ERROR, 0, GD_MSG_DICT_SET_FAILED,
@@ -5251,29 +5241,22 @@ glusterd_op_modify_op_ctx(glusterd_op_t op, void *ctx)
                 goto out;
             }
 
-            /* add 'node-name-%d' into op_ctx with value uuid_str.
-               this will be used to convert to hostname later */
+            /* Note 'uuid' will be used to convert to hostname later. */
             {
-                char *uuid_str = NULL;
-                char *uuid = NULL;
+                uuid_t uuid = {0};
                 int i;
 
                 for (i = 1; i <= count; i++) {
-                    keylen = snprintf(key, sizeof(key), "node-uuid-%d", i);
-                    ret = dict_get_strn(op_ctx, key, keylen, &uuid_str);
+                    snprintf(key, sizeof(key), GF_NODE_UUID_KEY, i);
+                    ret = dict_get_gfuuid(op_ctx, key, &uuid);
                     if (!ret) {
-                        keylen = snprintf(key, sizeof(key), "node-name-%d", i);
-                        uuid = gf_strdup(uuid_str);
-                        if (!uuid) {
+                        snprintf(key, sizeof(key), "node-name-%d", i);
+                        ret = dict_set_gfuuid(op_ctx, key, uuid, true);
+                        if (ret != 0) {
                             gf_msg_debug(this->name, 0,
-                                         "unable to create dup of"
-                                         " uuid_str");
+                                         "failed to set node name");
                             continue;
                         }
-                        ret = dict_set_dynstrn(op_ctx, key, keylen, uuid);
-                        if (ret != 0) {
-                            GF_FREE(uuid);
-                        }
                     }
                 }
             }
diff --git a/xlators/mgmt/glusterd/src/glusterd-peer-utils.c b/xlators/mgmt/glusterd/src/glusterd-peer-utils.c
index a74bc9138e5..a7cda00a551 100644
--- a/xlators/mgmt/glusterd/src/glusterd-peer-utils.c
+++ b/xlators/mgmt/glusterd/src/glusterd-peer-utils.c
@@ -494,18 +494,6 @@ glusterd_uuid_to_hostname(uuid_t uuid)
     return hostname;
 }
 
-char *
-gd_peer_uuid_str(glusterd_peerinfo_t *peerinfo)
-{
-    if ((peerinfo == NULL) || gf_uuid_is_null(peerinfo->uuid))
-        return NULL;
-
-    if (peerinfo->uuid_str[0] == '\0')
-        uuid_utoa_r(peerinfo->uuid, peerinfo->uuid_str);
-
-    return peerinfo->uuid_str;
-}
-
 gf_boolean_t
 glusterd_are_all_peers_up()
 {
@@ -691,8 +679,8 @@ gd_add_friend_to_dict(glusterd_peerinfo_t *friend, dict_t *dict,
     GF_VALIDATE_OR_GOTO(this->name, (dict != NULL), out);
     GF_VALIDATE_OR_GOTO(this->name, (prefix != NULL), out);
 
-    snprintf(key, sizeof(key), "%s.uuid", prefix);
-    ret = dict_set_dynstr_with_alloc(dict, key, uuid_utoa(friend->uuid));
+    snprintf(key, sizeof(key), GF_UUID_KEY, prefix);
+    ret = dict_set_gfuuid(dict, key, friend->uuid, true);
     if (ret) {
         gf_msg(this->name, GF_LOG_ERROR, 0, GD_MSG_DICT_SET_FAILED,
                "Failed to set key %s in dict", key);
@@ -840,7 +828,6 @@ gd_peerinfo_from_dict(dict_t *dict, const char *prefix)
     char key[64] = {
         0,
     };
-    char *uuid_str = NULL;
 
     conf = this->private;
     GF_VALIDATE_OR_GOTO(this->name, (conf != NULL), out);
@@ -857,16 +844,13 @@ gd_peerinfo_from_dict(dict_t *dict, const char *prefix)
         goto out;
     }
 
-    ret = snprintf(key, sizeof(key), "%s.uuid", prefix);
-    ret = dict_get_strn(dict, key, ret, &uuid_str);
+    ret = snprintf(key, sizeof(key), GF_UUID_KEY, prefix);
+    ret = dict_get_gfuuid(dict, key, &new_peer->uuid);
     if (ret) {
         gf_msg(this->name, GF_LOG_ERROR, 0, GD_MSG_DICT_GET_FAILED,
-               "Key %s not present in "
-               "dictionary",
-               key);
+               "Key %s not present in dictionary", key);
         goto out;
     }
-    gf_uuid_parse(uuid_str, new_peer->uuid);
 
     ret = gd_update_peerinfo_from_dict(new_peer, dict, prefix);
 
@@ -932,15 +916,13 @@ gd_add_peer_detail_to_dict(glusterd_peerinfo_t *peerinfo, dict_t *friends,
         0,
     };
     int keylen;
-    char *peer_uuid_str = NULL;
 
     xlator_t *this = THIS;
     GF_ASSERT(peerinfo);
     GF_ASSERT(friends);
 
-    peer_uuid_str = gd_peer_uuid_str(peerinfo);
-    keylen = snprintf(key, sizeof(key), "friend%d.uuid", count);
-    ret = dict_set_strn(friends, key, keylen, peer_uuid_str);
+    snprintf(key, sizeof(key), GF_FRIEND_UUID_KEY, count);
+    ret = dict_set_gfuuid(friends, key, peerinfo->uuid, true);
     if (ret) {
         gf_smsg(this->name, GF_LOG_ERROR, 0, GD_MSG_DICT_SET_FAILED, "Key=%s",
                 key, NULL);
diff --git a/xlators/mgmt/glusterd/src/glusterd-peer-utils.h b/xlators/mgmt/glusterd/src/glusterd-peer-utils.h
index f3821e71468..d10727009c4 100644
--- a/xlators/mgmt/glusterd/src/glusterd-peer-utils.h
+++ b/xlators/mgmt/glusterd/src/glusterd-peer-utils.h
@@ -38,9 +38,6 @@ glusterd_chk_peers_connected_befriended(uuid_t skip_uuid);
 char *
 glusterd_uuid_to_hostname(uuid_t uuid);
 
-char *
-gd_peer_uuid_str(glusterd_peerinfo_t *peerinfo);
-
 gf_boolean_t
 glusterd_are_all_peers_up();
 
diff --git a/xlators/mgmt/glusterd/src/glusterd-sm.h b/xlators/mgmt/glusterd/src/glusterd-sm.h
index a3a467f680a..a9461589e1e 100644
--- a/xlators/mgmt/glusterd/src/glusterd-sm.h
+++ b/xlators/mgmt/glusterd/src/glusterd-sm.h
@@ -65,9 +65,6 @@ typedef struct glusterd_sm_tr_log_ {
 
 struct glusterd_peerinfo_ {
     uuid_t uuid;
-    char uuid_str[50]; /* Retrieve this using
-                        * gd_peer_uuid_str ()
-                        */
     glusterd_friend_sm_state_t state;
     char *hostname;
     struct cds_list_head hostnames;
diff --git a/xlators/mgmt/glusterd/src/glusterd-snapshot.c b/xlators/mgmt/glusterd/src/glusterd-snapshot.c
index 2b55bd096a2..fec4e13109a 100644
--- a/xlators/mgmt/glusterd/src/glusterd-snapshot.c
+++ b/xlators/mgmt/glusterd/src/glusterd-snapshot.c
@@ -7159,20 +7159,14 @@ glusterd_get_each_snap_object_status(char **op_errstr, dict_t *rsp_dict,
 
     temp = NULL;
 
-    keylen = snprintf(key, sizeof(key), "%s.uuid", keyprefix);
+    keylen = snprintf(key, sizeof(key), GF_UUID_KEY, keyprefix);
     if (keylen < 0) {
         gf_smsg(this->name, GF_LOG_ERROR, errno, GD_MSG_COPY_FAIL, NULL);
         ret = -1;
         goto out;
     }
 
-    temp = gf_strdup(uuid_utoa(snap->snap_id));
-    if (temp == NULL) {
-        ret = -1;
-        goto out;
-    }
-
-    ret = dict_set_dynstrn(rsp_dict, key, keylen, temp);
+    ret = dict_set_gfuuid(rsp_dict, key, snap->snap_id, true);
     if (ret) {
         gf_msg(this->name, GF_LOG_ERROR, 0, GD_MSG_DICT_SET_FAILED,
                "Could not save "
diff --git a/xlators/mgmt/glusterd/src/glusterd-syncop.c b/xlators/mgmt/glusterd/src/glusterd-syncop.c
index cde66b5b346..862ec76be42 100644
--- a/xlators/mgmt/glusterd/src/glusterd-syncop.c
+++ b/xlators/mgmt/glusterd/src/glusterd-syncop.c
@@ -424,8 +424,7 @@ glusterd_volume_bitrot_scrub_use_rsp_dict(dict_t *aggr, dict_t *rsp_dict)
     char *last_scrub_time = NULL;
     char *scrub_time = NULL;
     char *volname = NULL;
-    char *node_uuid = NULL;
-    char *node_uuid_str = NULL;
+    uuid_t node_uuid;
     char *bitd_log = NULL;
     char *scrub_log = NULL;
     char *scrub_freq = NULL;
@@ -471,13 +470,11 @@ glusterd_volume_bitrot_scrub_use_rsp_dict(dict_t *aggr, dict_t *rsp_dict)
         gf_msg(this->name, GF_LOG_ERROR, 0, GD_MSG_DICT_SET_FAILED,
                "Failed to set count in dictonary");
 
-    keylen = snprintf(key, sizeof(key), "node-uuid-%d", src_count);
-    ret = dict_get_strn(rsp_dict, key, keylen, &node_uuid);
+    snprintf(key, sizeof(key), GF_NODE_UUID_KEY, src_count);
+    ret = dict_get_gfuuid(rsp_dict, key, &node_uuid);
     if (!ret) {
-        node_uuid_str = gf_strdup(node_uuid);
-        keylen = snprintf(key, sizeof(key), "node-uuid-%d",
-                          src_count + dst_count);
-        ret = dict_set_dynstrn(aggr, key, keylen, node_uuid_str);
+        snprintf(key, sizeof(key), GF_NODE_UUID_KEY, src_count + dst_count);
+        ret = dict_set_gfuuid(aggr, key, node_uuid, true);
         if (ret) {
             gf_msg_debug(this->name, 0, "failed to set node-uuid");
         }
diff --git a/xlators/mgmt/glusterd/src/glusterd-utils.c b/xlators/mgmt/glusterd/src/glusterd-utils.c
index e13e6a512ee..4028d61d362 100644
--- a/xlators/mgmt/glusterd/src/glusterd-utils.c
+++ b/xlators/mgmt/glusterd/src/glusterd-utils.c
@@ -3803,7 +3803,6 @@ glusterd_import_new_ta_brick(dict_t *peer_data, int32_t vol_count,
     int decommissioned = 0;
     glusterd_brickinfo_t *new_ta_brickinfo = NULL;
     char msg[256] = "";
-    char *brick_uuid_str = NULL;
 
     GF_ASSERT(peer_data);
     GF_ASSERT(vol_count >= 0);
@@ -3863,11 +3862,10 @@ glusterd_import_new_ta_brick(dict_t *peer_data, int32_t vol_count,
     if (brick_id)
         (void)snprintf(new_ta_brickinfo->brick_id,
                        sizeof(new_ta_brickinfo->brick_id), "%s", brick_id);
-    keylen = snprintf(key, sizeof(key), "%s.uuid", key_prefix);
-    ret = dict_get_strn(peer_data, key, keylen, &brick_uuid_str);
+    snprintf(key, sizeof(key), GF_UUID_KEY, key_prefix);
+    ret = dict_get_gfuuid(peer_data, key, &new_ta_brickinfo->uuid);
     if (ret)
         goto out;
-    gf_uuid_parse(brick_uuid_str, new_ta_brickinfo->uuid);
 
     *ta_brickinfo = new_ta_brickinfo;
 
@@ -3901,7 +3899,6 @@ glusterd_import_new_brick(dict_t *peer_data, int32_t vol_count,
     int decommissioned = 0;
     glusterd_brickinfo_t *new_brickinfo = NULL;
     char msg[256] = "";
-    char *brick_uuid_str = NULL;
 
     GF_ASSERT(peer_data);
     GF_ASSERT(vol_count >= 0);
@@ -3965,11 +3962,10 @@ glusterd_import_new_brick(dict_t *peer_data, int32_t vol_count,
     if (ret)
         goto out;
 
-    keylen = snprintf(key, sizeof(key), "%s.uuid", key_prefix);
-    ret = dict_get_strn(peer_data, key, keylen, &brick_uuid_str);
+    snprintf(key, sizeof(key), GF_UUID_KEY, key_prefix);
+    ret = dict_get_gfuuid(peer_data, key, &new_brickinfo->uuid);
     if (ret)
         goto out;
-    gf_uuid_parse(brick_uuid_str, new_brickinfo->uuid);
 
     *brickinfo = new_brickinfo;
 out:
@@ -9757,7 +9753,6 @@ glusterd_bitrot_volume_node_rsp(dict_t *aggr, dict_t *rsp_dict)
     uint64_t value = 0;
     char key[64] = "";
     int keylen;
-    char buf[1024] = "";
     int32_t i = 0;
     int32_t j = 0;
     char *last_scrub_time = NULL;
@@ -9813,10 +9808,8 @@ glusterd_bitrot_volume_node_rsp(dict_t *aggr, dict_t *rsp_dict)
         gf_msg(this->name, GF_LOG_ERROR, 0, GD_MSG_DICT_SET_FAILED,
                "Failed to set count");
 
-    snprintf(buf, sizeof(buf), "%s", uuid_utoa(MY_UUID));
-
-    snprintf(key, sizeof(key), "node-uuid-%d", i);
-    ret = dict_set_dynstr_with_alloc(aggr, key, buf);
+    snprintf(key, sizeof(key), GF_NODE_UUID_KEY, i);
+    ret = dict_set_gfuuid(aggr, key, MY_UUID, true);
     if (ret)
         gf_msg(this->name, GF_LOG_ERROR, 0, GD_MSG_DICT_SET_FAILED,
                "failed to set node-uuid");
@@ -9979,8 +9972,7 @@ glusterd_volume_rebalance_use_rsp_dict(dict_t *aggr, dict_t *rsp_dict)
 {
     char key[64] = "";
     int keylen;
-    char *node_uuid = NULL;
-    char *node_uuid_str = NULL;
+    uuid_t node_uuid;
     char *volname = NULL;
     dict_t *ctx_dict = NULL;
     double elapsed_time = 0;
@@ -9993,7 +9985,6 @@ glusterd_volume_rebalance_use_rsp_dict(dict_t *aggr, dict_t *rsp_dict)
     int32_t current_index = 1;
     int32_t value32 = 0;
     uint64_t value = 0;
-    char *peer_uuid_str = NULL;
     xlator_t *this = THIS;
 
     GF_ASSERT(rsp_dict);
@@ -10027,17 +10018,14 @@ glusterd_volume_rebalance_use_rsp_dict(dict_t *aggr, dict_t *rsp_dict)
         gf_msg("glusterd", GF_LOG_ERROR, 0, GD_MSG_DICT_GET_FAILED,
                "failed to get index from rsp dict");
 
-    keylen = snprintf(key, sizeof(key), "node-uuid-%d", index);
-    ret = dict_get_strn(rsp_dict, key, keylen, &node_uuid);
+    snprintf(key, sizeof(key), GF_NODE_UUID_KEY, index);
+    ret = dict_get_gfuuid(rsp_dict, key, &node_uuid);
     if (!ret) {
-        node_uuid_str = gf_strdup(node_uuid);
-
-        /* Finding the index of the node-uuid in the peer-list */
+        /* Finding the index of the node-uuid in the peer list. */
         RCU_READ_LOCK;
         cds_list_for_each_entry_rcu(peerinfo, &conf->peers, uuid_list)
         {
-            peer_uuid_str = gd_peer_uuid_str(peerinfo);
-            if (strcmp(peer_uuid_str, node_uuid_str) == 0)
+            if (gf_uuid_compare(node_uuid, peerinfo->uuid) == 0)
                 break;
 
             current_index++;
@@ -10054,9 +10042,9 @@ glusterd_volume_rebalance_use_rsp_dict(dict_t *aggr, dict_t *rsp_dict)
                        "Failed to set count");
         }
 
-        /* Setting the same index for the node, as is in the peerlist.*/
-        keylen = snprintf(key, sizeof(key), "node-uuid-%d", current_index);
-        ret = dict_set_dynstrn(ctx_dict, key, keylen, node_uuid_str);
+        /* Setting the same index for the node, as is in the peerlist. */
+        snprintf(key, sizeof(key), GF_NODE_UUID_KEY, current_index);
+        ret = dict_set_gfuuid(ctx_dict, key, node_uuid, true);
         if (ret) {
             gf_msg_debug(this->name, 0, "failed to set node-uuid");
         }
@@ -10645,10 +10633,7 @@ glusterd_defrag_volume_node_rsp(dict_t *req_dict, dict_t *rsp_dict,
     char *volname = NULL;
     glusterd_volinfo_t *volinfo = NULL;
     char key[64] = "";
-    int keylen;
     int32_t i = 0;
-    char buf[64] = "";
-    char *node_str = NULL;
     int32_t cmd = 0;
 
     GF_ASSERT(req_dict);
@@ -10687,11 +10672,8 @@ glusterd_defrag_volume_node_rsp(dict_t *req_dict, dict_t *rsp_dict,
         gf_msg(THIS->name, GF_LOG_ERROR, 0, GD_MSG_DICT_SET_FAILED,
                "Failed to set count");
 
-    snprintf(buf, sizeof(buf), "%s", uuid_utoa(MY_UUID));
-    node_str = gf_strdup(buf);
-
-    keylen = snprintf(key, sizeof(key), "node-uuid-%d", i);
-    ret = dict_set_dynstrn(op_ctx, key, keylen, node_str);
+    snprintf(key, sizeof(key), GF_NODE_UUID_KEY, i);
+    ret = dict_set_gfuuid(op_ctx, key, MY_UUID, true);
     if (ret)
         gf_msg(THIS->name, GF_LOG_ERROR, 0, GD_MSG_DICT_SET_FAILED,
                "failed to set node-uuid");
